package org.artifactory.metrics.framework;

/**
 * Holds all feature adoption actions that are tracked as part of Feature Adoption.
 *
 * @author Oleksandr Legenkiy
 */
public enum FeatureAdoptionActions {

    CREATE_ARCHIVING_POLICY_API_ADMIN("create_archiving_policy_api_admin"),
    CREATE_ARCHIVING_POLICY_UI_ADMIN("create_archiving_policy_ui_admin"),
    VISIT_ARCHIVING_POLICY_LIST_PAGE_ADMIN("visit_archiving_policy_list_page_admin"),
    RESOURCE_ARCHIVED_VIA_ARCHIVING_POLICY("resource_archived_via_archiving_policy"),
    CREATE_REPOSITORY_BY_UI_ADMIN("create_repository_by_ui_admin"),
    CREATE_OR_REPLACE_REPOSITORY_BY_REST("create_or_replace_repository_by_rest"),
    DOWNLOAD_PACKAGE_FROM_REMOTE("download_package_from_remote"),
    ADD_PACKAGE("add_package"),
    ARTIFACT_MIRRORED_TO_MEMBER("artifact_mirrored_to_member"),
    CREATED_NEW_FEDERATED_REPO("created_new_federated_repo"),
    ADDED_NEW_FEDERATED_MEMBER("added_new_federated_member"),
    UPDATED_FEDERATED_REPO("updated_federated_repo"),
    FULL_SYNC_TRIGGERED("full_sync_triggered"),
    TOKEN_REGISTRATION("token_registered"),
    ;

    private final String action;

    FeatureAdoptionActions(String action) {
        this.action = action;
    }

    public String action() {
        return action;
    }
}
