package org.artifactory.queue;

import org.artifactory.descriptor.repo.RepoType;
import org.artifactory.queue.register.QueueConfigurationRegistrar;
import org.artifactory.storage.db.event.entity.enums.NodeEventCursorType;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class ExampleMultipleQueueRegistry implements QueueConfigurationRegistrar {

    private final List<String> destinations;

    public ExampleMultipleQueueRegistry(String... destinations) {
        this.destinations = List.of(destinations);
    }

    @Override
    public RepoType getRepoType() {
        return RepoType.Maven;
    }

    @Override
    public List<QueueConfiguration> getConfigurations(String repoKey) {
        List<QueueConfiguration> configurations = new ArrayList<>();
        for (String destination : destinations) {
            QueueConfiguration configuration = QueueConfiguration.builder()
                    .cursorType(NodeEventCursorType.FEDERATED_REPLICATION)
                    .variant(destination)
                    .implementor((events, key) -> {})
                    .build();
            configurations.add(configuration);
        }
        return configurations;
    }


}
