package org.artifactory.queue;

import org.artifactory.queue.register.QueueConfigurationRegistrar;
import org.artifactory.repo.RepoDetailsType;
import org.artifactory.storage.db.event.entity.enums.NodeEventCursorType;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class ExampleVirtualSingleQueueRegistry implements QueueConfigurationRegistrar {

    private final QueueConfiguration configuration;

    public ExampleVirtualSingleQueueRegistry() {
        configuration = QueueConfiguration.builder()
                .cursorType(NodeEventCursorType.INCREMENTAL_INDEX)
                .implementor((events, key) -> {})
                .build();
    }

    @Override
    public RepoDetailsType getRepoDetailsType() {
        return RepoDetailsType.VIRTUAL;
    }

    @Override
    public List<QueueConfiguration> getConfigurations(String repoKey) {
        return List.of(configuration);
    }

}
