package org.artifactory.storage.event;

import org.testng.annotations.Test;

import java.util.HashSet;
import java.util.Set;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertNotEquals;

/**
 * @author Alexei Vainshtein
 */
public class EventInfoTest {

    @Test
    public void testEquals() {
        EventInfo info1 = new EventInfo(EventType.create, "temp/path");
        EventInfo info2 = new EventInfo(EventType.create, "temp/path2");

        assertNotEquals(info2, info1);

        EventInfo info3 = new EventInfo(EventType.create, "temp/path");
        assertEquals(info1, info3);

        EventInfo info4 = new EventInfo(30L, EventType.create, "temp/path");
        assertEquals(info1, info4);

        Set<String> hints = new HashSet<>();
        hints.add("test");
        EventInfo info5 = new EventInfo(30L, EventType.create, "temp/path", hints);
        assertNotEquals(info1, info5);
    }

    @Test
    public void testHash() {
        EventInfo info1 = new EventInfo(EventType.create, "temp/path");
        EventInfo info2 = new EventInfo(EventType.create, "temp/path2");
        assertNotEquals(info2.hashCode(), info1.hashCode());

        EventInfo info4 = new EventInfo(30L, EventType.create, "temp/path");
        assertEquals(info1.hashCode(), info4.hashCode());

        Set<String> hints = new HashSet<>();
        hints.add("test");
        EventInfo info5 = new EventInfo(30L, EventType.create, "temp/path", hints);
        assertNotEquals(info1.hashCode(), info5.hashCode());
    }

}